'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GlobalListeners = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _events = require('../../utils/events');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// $FlowFixMe


var GlobalListeners = exports.GlobalListeners = function (_Component) {
  _inherits(GlobalListeners, _Component);

  function GlobalListeners() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, GlobalListeners);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = GlobalListeners.__proto__ || Object.getPrototypeOf(GlobalListeners)).call.apply(_ref, [this].concat(args))), _this), _this._removeListenersAndToggle = function () {
      var _this$props = _this.props,
          optionsIsOpen = _this$props.optionsIsOpen,
          optionsRef = _this$props.optionsRef;

      _this._removeGlobalListeners();

      // before toggle, ensure options is open and optionsRef exists on DOM
      if (!optionsIsOpen || !optionsRef || !optionsRef.current) {
        return;
      }
      _this.props.toggleOpen();
    }, _this._getDocumentListeners = function () {
      return {
        click: _this.handleDocumentClick,
        scroll: _this.handleDocumentScroll
      };
    }, _this._getWindowListeners = function () {
      return {
        resize: _this.handleWindowResize
      };
    }, _this.handleDocumentClick = function (event) {
      var _this$props2 = _this.props,
          optionsIsOpen = _this$props2.optionsIsOpen,
          rootRef = _this$props2.rootRef;

      // ensure Options is open

      if (!optionsIsOpen || !rootRef || !rootRef.current) {
        return;
      }

      // return early if the user clicked an element within the parent component
      // for example, the parent component could be Autocomplete or Select
      if ((0, _events.targetIsDescendant)(event, rootRef.current)) {
        return;
      }

      // otherwise, remove all listeners and close Options
      _this._removeListenersAndToggle();
    }, _this.handleWindowResize = function () {
      return _this._removeListenersAndToggle();
    }, _this.handleDocumentScroll = function () {
      return _this._removeListenersAndToggle();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }
  // define static properties


  _createClass(GlobalListeners, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var optionsIsOpen = this.props.optionsIsOpen;

      // if Options is transferring from closed to open, add listeners
      // if Options is transferring from open to closed, remove listeners

      if (!optionsIsOpen && nextProps.optionsIsOpen) {
        (0, _events.addWindowListeners)(this._getWindowListeners());
        (0, _events.addDocumentListeners)(this._getDocumentListeners());
      } else if (optionsIsOpen && !nextProps.optionsIsOpen) {
        this._removeGlobalListeners();
      }
    }

    // before unmounting, remove all global listeners

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._removeGlobalListeners();
    }

    // removes all event listeners from document and window

  }, {
    key: '_removeGlobalListeners',
    value: function _removeGlobalListeners() {
      (0, _events.removeDocumentListeners)(this._getDocumentListeners());
      (0, _events.removeWindowListeners)(this._getWindowListeners());
    }

    // removes all global listeners, then closes Options

  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        this.props.children()
      );
    }
  }]);

  return GlobalListeners;
}(_react.Component);

GlobalListeners.displayName = 'GlobalListeners';
GlobalListeners.defaultProps = {
  optionsIsOpen: false
};
//# sourceMappingURL=GlobalListeners.js.map